// DDS_LED_1   mit Umschaltung Kanalgruppe 1/2 via Input "A1" 

#include <Rotary.h>

//Setup some items
#define W_CLK 8   // Pin 8 - connect to AD9850 module word load clock pin (CLK)
#define FQ_UD 9   // Pin 9 - connect to freq update pin (FQ)
#define DATA 10   // Pin 10 - connect to serial data load pin (DATA)
#define RESET 11  // Pin 11 - connect to reset pin (RST) 
#define pulseHigh(pin) {digitalWrite(pin, HIGH); digitalWrite(pin, LOW); }

Rotary r = Rotary(2,3); // sets the pins the rotary encoder uses.  Must be interrupt pins.

int_fast32_t rx=14100000; // Starting frequency of VFO 14.100 MHz
int_fast32_t rx2=1; // variable to hold the updated frequency
int_fast32_t increment = 100; // VFO increment in Hz.

word channel_raw;
int  channel;
int  channel_old;

const int inputPin = A1;

#define LED1 4  // #4
#define LED2 5  // #5 
#define LED3 6  // #6
#define LED4 7  // #7
#define LED5 12  // #12
#define LED6 13  // #13

////////////////////////////////////////////////////////////
void setup() {    
  Serial.begin(9600);    
  pinMode(A0,INPUT); 
  PCICR |= (1 << PCIE2);
  PCMSK2 |= (1 << PCINT18) | (1 << PCINT19);
  sei();
  pinMode(FQ_UD, OUTPUT);
  pinMode(W_CLK, OUTPUT);
  pinMode(DATA, OUTPUT);
  pinMode(RESET, OUTPUT); 
  pulseHigh(RESET);
  pulseHigh(W_CLK);
  pulseHigh(FQ_UD);  // this pulse enables serial mode on the AD9850 - Datasheet page 12.

  digitalWrite(inputPin,HIGH); 

  pinMode(LED1, OUTPUT); 
  pinMode(LED2, OUTPUT); 
  pinMode(LED3, OUTPUT); 
  pinMode(LED4, OUTPUT); 
  pinMode(LED5, OUTPUT); 
  pinMode(LED6, OUTPUT); 

  digitalWrite(LED1, HIGH);
  digitalWrite(LED2, HIGH);
  digitalWrite(LED3, HIGH);
  digitalWrite(LED4, HIGH);
  digitalWrite(LED5, HIGH);
  digitalWrite(LED6, HIGH);
 }

////////////////////////////////////////////////////////////
ISR(PCINT2_vect) {
  unsigned char result = r.process();
  if (result) {    
    if (result == DIR_CW){rx=rx+increment;}
    else {rx=rx-increment;};       
  }
}

////////////////////////////////////////////////////////////
// frequency calc from datasheet page 8 = <sys clock> * <frequency tuning word>/2^32
void sendFrequency(double frequency) {  
  int32_t freq = frequency * 4294967295/125000000;  // note 125 MHz clock on AD9850.  You can make 'slight' tuning variations here by adjusting the clock frequency.
  for (int b=0; b<4; b++, freq>>=8) {
    tfr_byte(freq & 0xFF);
  }
  tfr_byte(0x000);   // Final control byte, all 0 for AD9850 chip
  pulseHigh(FQ_UD);  // Done!  Should see output
}

////////////////////////////////////////////////////////////
// transfers a byte, a bit at a time, LSB first to the AD9850 via serial DATA line
void tfr_byte(byte data) {
  for (int i=0; i<8; i++, data>>=1) 
  {
    digitalWrite(DATA, data & 0x01);
    pulseHigh(W_CLK);   //after each bit sent, CLK is pulsed high
  }
}

////////////////////////////////////////////////////////////
void loop() {
 channel_raw = analogRead(A0);
// Serial.println(channel_raw);
 channel_raw = channel_raw/174;
 channel = channel_raw; 
// Serial.println(channel);

int val = digitalRead(inputPin);
  if(val == HIGH && channel != channel_old)  { 
// replace rx values according to your personal requirements
     if (channel==0) { rx=14100000; SetLED1(); }  // 14.100 MHz
else if (channel==1) { rx=14101000; SetLED2(); }  // 14.101 MHz
else if (channel==2) { rx=14102000; SetLED3(); }  // 14.102 MHz
else if (channel==3) { rx=14103000; SetLED4(); }  // 14.103 MHz
else if (channel==4) { rx=14104000; SetLED5(); }  // 14.104 MHz
else if (channel==5) { rx=14105000; SetLED6(); }  // 14.105 MHz
  channel_old = channel;  
  }
  else if (channel != channel_old)  { 
// replace rx values according to your personal requirements
     if (channel==0) { rx=14150000; SetLED1(); }  // 14.150 MHz
else if (channel==1) { rx=14151000; SetLED2(); }  // 14.151 MHz
else if (channel==2) { rx=14152000; SetLED3(); }  // 14.152 MHz
else if (channel==3) { rx=14153000; SetLED4(); }  // 14.153 MHz
else if (channel==4) { rx=14154000; SetLED5(); }  // 14.154 MHz
else if (channel==5) { rx=14155000; SetLED6(); }  // 14.155 MHz
  channel_old = channel;  
  }

  if (rx != rx2)  {    
  sendFrequency(rx);
  Serial.println(rx);
  rx2 = rx;
  }  
}  

////////////////////////////////////////////////////////////
void SetLED1()  {
  digitalWrite(LED1, LOW);
  digitalWrite(LED2, HIGH);
  digitalWrite(LED3, HIGH);
  digitalWrite(LED4, HIGH);
  digitalWrite(LED5, HIGH);
  digitalWrite(LED6, HIGH); }

void SetLED2()  {
  digitalWrite(LED1, HIGH);
  digitalWrite(LED2, LOW);
  digitalWrite(LED3, HIGH);
  digitalWrite(LED4, HIGH);
  digitalWrite(LED5, HIGH);
  digitalWrite(LED6, HIGH); }

void SetLED3()  {
  digitalWrite(LED1, HIGH);
  digitalWrite(LED2, HIGH);
  digitalWrite(LED3, LOW);
  digitalWrite(LED4, HIGH);
  digitalWrite(LED5, HIGH);
  digitalWrite(LED6, HIGH); }
void SetLED4()  {
  digitalWrite(LED1, HIGH);
  digitalWrite(LED2, HIGH);
  digitalWrite(LED3, HIGH);
  digitalWrite(LED4, LOW);
  digitalWrite(LED5, HIGH);
  digitalWrite(LED6, HIGH); }

void SetLED5()  {
  digitalWrite(LED1, HIGH);
  digitalWrite(LED2, HIGH);
  digitalWrite(LED3, HIGH);
  digitalWrite(LED4, HIGH);
  digitalWrite(LED5, LOW);
  digitalWrite(LED6, HIGH); }

void SetLED6()  {
  digitalWrite(LED1, HIGH);
  digitalWrite(LED2, HIGH);
  digitalWrite(LED3, HIGH);
  digitalWrite(LED4, HIGH);
  digitalWrite(LED5, HIGH);
  digitalWrite(LED6, LOW);  }


  

